export declare type FormListener = (name: string) => void;
export declare type FormResult = boolean | string | number | object | null | undefined;
export declare type FormValidator = (value: any, values: any) => FormResult | Promise<FormResult>;
export declare type FormRules = {
    [key: string]: FormValidator;
};
export declare type FormErrors = {
    [key: string]: string | undefined;
};
export declare class FormStore<T extends Object = any> {
    private initialValues;
    private listeners;
    private values;
    private rules;
    private errors;
    constructor(values?: Partial<T>, rules?: FormRules);
    private notify;
    get(name?: string): any;
    set(values: Partial<T>): Promise<void>;
    set(name: string, value: any, validate?: boolean): Promise<void>;
    reset(): void;
    error(): FormErrors;
    error(name: number | string): string | undefined;
    error(name: string, value: string | undefined): string | undefined;
    validate(): Promise<[Error | undefined, T]>;
    validate(name: string): Promise<[Error | undefined, any]>;
    subscribe(listener: FormListener): () => void;
}
